from Products.ATContentTypes import interface as atct

from p4a.audio import interfaces as audio
from p4a.video import interfaces as video
# from collective.dancing import interfaces as hades
from p4a.audio import interfaces as audio
from p4a.video import interfaces as video

from zope.interface import directlyProvides, directlyProvidedBy

from ZODB.POSException import ReadConflictError

markers = [
  audio.IAnyAudioCapable,
  audio.IAudio,
  audio.IAudioContainer,
  audio.IAudioContainerEnhanced,
  audio.IAudioDataAccessor,
  audio.IAudioDataAccessor,
  audio.IAudioEnhanced,
  audio.IAudioProvider,
  audio.IAudioSupport,
  audio.IBasicAudioSupport,
  audio.IMediaActivator,
  audio.IMediaPlayer,
  audio.IPossibleAudio,
  audio.IPossibleAudioContainer,
  video.IPossibleVideo,
  video.IPossibleVideoContainer,
  video.IAnyVideoCapable,
  video.IVideoEnhanced,
  video.IVideo,
  video.IVideoDataAccessor,
  video.IMediaPlayer,
  video.IVideoContainerEnhanced,
  video.IVideoProvider,
  video.IBasicVideoSupport,
  video.IVideoSupport,
  video.IMediaActivator,
  
]

remove_markers = [
  audio.IAudioContainerEnhanced,
]

ignore_items = [
  'CacheSetup_OFSCache',
  'CacheSetup_PageCache',
  'CacheSetup_ResourceRegistryCache',
  'FckHTTPCache',
  'HTTPCache',
  'MailHost',
  'RAMCache',
  'ResourceRegistryCache',
  'acl_users',
  'archetype_tool',
  'caching_policy_manager',
  'content_type_registry',
  'error_log',
  'formgen_tool',
  'kupu_library_tool',
  'marshaller_registry',
  'mimetypes_registry',
  'plone_utils',
  'reference_catalog',
  'translation_service',
  'uid_catalog',
]


folder_types = [
  atct.IATFolder,
  atct.IATBTreeFolder,
]

def is_folder(context):
  for type in folder_types:
    if type.providedBy(context):
      return True
  return False

def exorcise(site, context, path='', readonly=True,
             itemcount=0, objcount=0):
  if not path: path = str(site)
  original_path = path
  changes = []
  found = []
  try:
    for key in context.keys():
      item = context[key]
      itemcount = itemcount + 1
      if atct.IATContentType.providedBy(item): #and \
        objcount = objcount + 1
        path = original_path + '/%s' % key
#         not key.startswith('portal_') and key not in ignore_items:
        print "check %s" % path
        for marker in markers:
          if marker.providedBy(item):
            print "found %s: %s" % ( key, marker )
            if marker in remove_markers:
              if not readonly:
                directlyProvides(item, directlyProvidedBy(item)-marker)
                log_action = "removed"
              else:
                log_action = "would remove"
              log_msg = "%s %s from %s directly provides." % (log_action, marker, key)
              print log_msg
              changes.append( log_msg )
        if is_folder(item):
          print "recurse %s" % path
          recur = exorcise(item, item, path, readonly = readonly,
                           itemcount= itemcount, objcount= objcount)
          if recur: changes.append( recur )
    return changes
  except RuntimeError:
    print "runtime error, key: %s, site: %s" % ( key, site )
  except ReadConflictError:
    print "ZODB.POSException.ReadConflictError, key: %s, site: %s" % ( key, site )
    return []
  except KeyboardInterrupt:
    import sys
    sys.exit()
#  except:
#    print "unknown error, key: %s, site: %s" % ( key, site )
  print "%s items, %s objects" % (itemcount, objcount)

def scan_all_fgr_structure(root):
 try:
  found = {}
  for key in root.keys():
    item = root[key]
    if hasattr(item, 'keys') and 'portal' in item.keys():
      changes = exorcise(item.portal, item.portal, path="/sites/%s" % key)
      if changes:
        found[key] = (item, changes)
  return found
 except KeyboardInterrupt:
    import sys
    sys.exit()

def implement_changes(changed):
 try:
  for key in changed.keys():
    item = changed[key][0].portal
    exorcise(item, item, readonly=False)
 except KeyboardInterrupt:
    import sys
    sys.exit()
